c Sample file for Rosenbrock function
        double precision, dimension(:), allocatable :: x
        double precision options(13), f
        integer n
        logical flg,flfc,flgc
        external rosenbf,rosenbg,null
c Flag for the use of analytically calculated gradients:        
          flg=.true.
c Flags for constraints are set to 0:
          flfc=.false.
          flgc=.false.
c Allocate array X:          
         n=2
         allocate (x(n))
c Use the default optional parameters:
         call soptions(options)
c Starting point:
         x(1)=-1.2d0
         x(2)=1.d0
c Call the solver:         
         call solvopt(n,x,f,rosenbf,flg,rosenbg,options,
     1    flfc,null,flgc,null)
c Display the results:
      print '(//5x,a)','Function Value ===== Evaluations == Iterations'
      print '(/ 1x,g22.15,2x,i5,2h +,i5,5x,i5)',
     1   f,idnint(options(10)),idnint(options(11)),idnint(options(9))
      print '(//1x,16hOptimum Point X:,//((1x,g22.15)))', x

        deallocate (x)
        end

      subroutine rosenbf(x,f)
c ROSENBF returns the function value at a point
c for Rosenbrock Saddle Function 
      double precision x(2),f,one,hundr
      data one/1.d0/,hundr/1.d2/
      f=hundr*(x(2)-x(1)**2)**2+(one-x(1))**2
      end
      subroutine rosenbg(x,g)
c ROSENBG returns the gradient at a point
c for Rosenbrock Saddle Function 
      double precision x(2),g(2),fhund,thund,one,two
      data one/1.d0/,two/2.d0/,fhund/4.d2/,thund/2.d2/
      g(1)=-fhund*(x(2)-x(1)**2)*x(1)-two*(one-x(1))
      g(2)= thund*(x(2)-x(1)**2)
      end
