c Sample file for Shor function
        double precision, dimension(:), allocatable :: x
        double precision options(13), f
        integer n
        logical flg, flfc, flgc
        external shorf, shorg, null
c Flag for the use of analytically calculated gradients:        
          flg=.true.
c Flags for constraints are set to 0:
          flfc=.false.
          flgc=.false.
c Allocate array X:          
         n=5
         allocate (x(n))
c Initialize the problem constants:
         call shorinit(x)
c Use the default optional parameters:
         call soptions(options)
c Call the solver:         
         call solvopt(n,x,f,shorf,flg,shorg,options,
     1    flfc,null,flgc,null)
c Display the results:
      print '(//5x,a)','Function Value ===== Evaluations == Iterations'
      print '(/ 1x,g22.15,2x,i5,2h +,i5,5x,i5)',
     1   f,idnint(options(10)),idnint(options(11)),idnint(options(9))
      print '(//1x,16hOptimum Point X:,//((1x,g22.15)))', x

        deallocate (x)
        end

c  Initialization routine:
      
      subroutine shorinit(x)
      double precision a(5,10),b(10),x(5)
      common/shorab/a,b
       
       a(1,1)=0.d0
       a(1,2)=2.d0
       a(1,3)=1.d0
       a(1,4)=1.d0
       a(1,5)=3.d0
       a(1,6)=0.d0
       a(1,7)=1.d0
       a(1,8)=1.d0
       a(1,9)=0.d0
       a(1,10)=1.d0
       a(2,1)=0.d0
       a(2,2)=1.d0
       a(2,3)=2.d0
       a(2,4)=4.d0
       a(2,5)=2.d0
       a(2,6)=2.d0
       a(2,7)=1.d0
       a(2,8)=0.d0
       a(2,9)=0.d0
       a(2,10)=1.d0
       a(3,1)=0.d0
       a(3,2)=1.d0
       a(3,3)=1.d0
       a(3,4)=1.d0
       a(3,5)=1.d0
       a(3,6)=1.d0
       a(3,7)=1.d0
       a(3,8)=1.d0
       a(3,9)=2.d0
       a(3,10)=2.d0
       a(4,1)=0.d0
       a(4,2)=1.d0
       a(4,3)=1.d0
       a(4,4)=2.d0
       a(4,5)=0.d0
       a(4,6)=0.d0
       a(4,7)=1.d0
       a(4,8)=2.d0
       a(4,9)=1.d0
       a(4,10)=0.d0
       a(5,1)=0.d0
       a(5,2)=3.d0
       a(5,3)=2.d0
       a(5,4)=2.d0
       a(5,5)=1.d0
       a(5,6)=1.d0
       a(5,7)=1.d0
       a(5,8)=1.d0
       a(5,9)=0.d0
       a(5,10)=0.d0
       
       b(1)=1.d0
       b(2)=5.d0
       b(3)=1.d1
       b(4)=2.d0
       b(5)=4.d0
       b(6)=3.d0
       b(7)=1.7d0
       b(8)=2.5d0
       b(9)=6.d0
       b(10)=4.5d0
       
       x(1)=-1.d0
       x(2)= 1.d0
       x(3)=-1.d0
       x(4)= 1.d0
       x(5)=-1.d0
       end
        subroutine shorf(x,f)
c Function SHORF returns the function value at a point
c for Shor's piece-wise quadratic function 
        double precision x(5),f,a(5,10),b(10),d,s
        integer i, j
        common/shorab/a,b
        f=0.d0
        do i=1,10
          s=0.d0
          do j=1,5
             s=s+(x(j)-a(j,i))**2
          enddo 
          d=b(i)*s
          if (d.gt.f) f=d
        enddo
        end
        subroutine shorg(x,g)
c Function SHORG returns the gradient vector 
c of Shor's piece-wise quadratic function at a point
        double precision x(5),g(5),f,a(5,10),b(10),d,s
        integer i, j, k
        common/shorab/a,b
        f=0.d0
        do i=1,10
          s=0.d0
          do j=1,5
             s=s+(x(j)-a(j,i))**2
          enddo 
          d=b(i)*s
          if (d.gt.f) then
            f=d
            k=i
          endif  
        enddo
        do j=1,5
          g(j)=b(k)*.5d0*(x(j)-a(j,k))
        enddo
        end
